#!/usr/bin/perl -w

# Skrypt wysyajcy SMS-y na wszystkie polskie sieci przez bramk
# Era Omnix Podstawowa (tj. z koniecznoci logowania).
# http://www.eraomnix.pl/sms/do/singleSignonFromXAction
# Napisany w Perlu. 
# Wymaga: perl + LWP (RPM dla RedHat: perl-libwww)
#
# (c) 2003 Jacek Fiok <jfiok@jfiok.org>; http://sms.jfiok.org
#
# Podzikowania: Piotr Wodarczyk <piotr@wlodarczyk.waw.pl>
#
# wysya wiadomoci: dowolnie dugie w kawakach po 122 znakw; sieci: ERA GSM

use strict;
use HTTP::Request::Common;
use HTTP::Cookies;
use LWP::UserAgent;
# use LWP::Debug qw(+ -conns);
# LWP::Debug::trace('send()');

# ----------------------- pomocnicze -------------------------
my $debug = 0;				# czy "tryb gadatliwy"

sub debug { if ($debug) { print "[", shift, "]\n"; } }

sub zakoncz {
  my ($tekst, $ret) = @_;
  print "$tekst\n";
  exit $ret;
}

# format struktury danych:
# string ktry moemy znale w odpowiedzi z serwera =>
# [co naley z niego wywnioskowa-opis, kod powrotu ze skryptu ]
my %odpowiedzi = (
	"Skrzynka wiadomoci" => ["Wszystko OK", 0],
	"Zy numer" => ["Zy numer!", 2],
	"zosta wyczerpany" => ["Limit wiadomoci na dzi przekroczony!", 3]
);

# gwna procedurka analizujca odpowied serwera
# jeli nie umiemy nic wywnioskowa -> rzucamy [Nieznana Odpowiedz, 127]
sub analizujWynik {
	my $res = $_[0];
	my $searchString;
	my @val;
	while ( ($searchString, @val) = each (%odpowiedzi) ) {
	  if ($res =~ /$searchString/ ) {
		  print $odpowiedzi{$searchString}[0], "\n";
		  exit $odpowiedzi{$searchString}[1];
	  }		  
	}
	# jeli nie znaleziono w opisach
	print "Nieznana odpowied:\n$res\n";
	exit 127;
}

# getCookie ($nazwa) -> warto cookie; wymaga: $cookie_jar.
my $ckey = "";
my $cval = "";
my $cookie_jar = HTTP::Cookies->new;
# zwraca warto ciasteczka dla podanej nazwy klucza
sub cookieScanner {
	# my $i; for ($i=0; $i<5; $i++) { print $i, " : ", $_[$i], "\n"; }
	($ckey eq $_[1]) and $cval = $_[2]; 
}
sub getCookie {
	$cval = "";
	$ckey = shift;
	$cookie_jar->scan (\&cookieScanner);
	return $cval;
}

my $ua = new LWP::UserAgent;
$ua->timeout(30);
$ua->agent("Mozilla/5.0 Galeon/1.2.7 (X11; Linux i686; U;) Gecko/20021216");
$ua->env_proxy();
$ua->cookie_jar($cookie_jar);

# odwiedza stron $_[0]; w razie bdu wychodzi z tekstem $_[1] i kodem $_[2].
# w zmiennej globalnej $res lduje HTML -- wynik zapytania.
my $res; my $req;
sub visit {
        $res = $ua->request (GET $_[0]);
        if (!($res->is_success)) { zakoncz($_[1], $_[2]); }
}
# ----------------------- main() -----------------------------

select(STDERR); $| = 1;     # make unbuffered
select(STDOUT); $| = 1;     # make unbuffered

if ($#ARGV != 3 ) { die "Za ilo parametrw - podaj numer i tre sms-a"; }

my $numer = $ARGV[0];
my $tresc = $ARGV[1];
my $username = $ARGV[2];
my $password = $ARGV[3];

# wstpna obrbka numerw. nazw uytkownika na bramce ma by nr telefonu, lub e-mail.
# jeli numer, to ma si zaczyna na "48", bez plusa. wpp zostaw bez zmian.
$username =~ s/^\+//;
if (($username =~ /^[0-9]/) and (!($username =~ /^48/))) { $username = "48".$username; }
$numer =~ s/^\+48//;
$numer =~ s/^00//;

push @{ $ua->requests_redirectable }, 'POST';

# --------- konwersacja -----------

# 1. get sms-index
visit ("http://www.eraomnix.pl/sms/login/login.jsp",
       "Bd przy otwieraniu formularza [1]", 1);
# 2. send the POST login form
debug ("Logging in");
$req = POST "http://www.eraomnix.pl/sms/do/j_security_check", [
	j_username => $username,
	j_password => $password
];
$req->referer ("http://www.eraomnix.pl/sms/login/login.jsp");
$res = $ua->request($req);
if (!($res->is_success)) { zakoncz("Bd przy logowaniu - zerwane poczenie [2]", 1); }
if (!($res->content =~ /Limit wiadomoci/)) { 
	zakoncz("Bd przy logowaniu - nieprawidowe haso [2]", 6); 
} 
debug ("zalogowany");

my $poczatek=0;
my $dlugosc=122;

my $wiadomosc=$tresc;
my $ilosc_smsow = 1; 

if ((length($wiadomosc) % $dlugosc) != 0) { 
    $ilosc_smsow = ((length($wiadomosc) - (length($wiadomosc) % $dlugosc)) / $dlugosc) + 1; 
} else {
    $ilosc_smsow = length($wiadomosc) / $dlugosc;
}

debug("Liczba smsw do wysania: ".$ilosc_smsow."\n");

# ptla wysyajca po kawaku
for (my $i=1;$i<=$ilosc_smsow;$i++) {
	$tresc=substr($wiadomosc,$poczatek,$dlugosc);
	$poczatek += $dlugosc;

	my $sms_zostalo = 666;
	if ($res->content =~ /Limit wiadomoci ([0-9]+)\./) { $sms_zostalo = $1; }
	if ($sms_zostalo == 666) { zakoncz ("Nie mog odczyta iloci dostpnych SMSw", 1); }
	if ($sms_zostalo == 0) { zakoncz ("Limit wiadomoci na ten miesic przekroczony", 3); }

	# 3. obejrzyj preview
	$req = POST 'http://www.eraomnix.pl/sms/do/previewSMS', [
		phoneNumber => $numer,
		smsContent  => $tresc,
		reply		=> '',
		signature	=> '',
		"actionKey.x"	=> 0,
		"actionKey.y"	=> 0
	];

	$req->referer('http://www.eraomnix.pl:80/sms/do/singleSignonFromXAction;jsessionid='.getCookie("JSESSIONID"));
	debug ("przechodz do podgldu wysania...");
	$res = $ua->request($req);
	if (!($res->is_success)) { zakoncz("Bd przy podgldzie wiadomoci [3]", 1); }

	# 4. wylij.
	my $token = "";
	if ($res->content =~ /Niepoprawny numer telefonu/ ) { zakoncz ("Zy numer!", 2); }
	if ($res->content =~ /TOKEN=([^"]+)"/ ) { $token = $1; } else { zakoncz ("Nie widze tokena?!", 127); }

	visit ("http://www.eraomnix.pl/sms/do/sendSMS?org.apache.struts.taglib.html.TOKEN=".$token, "Bd przy wysyaniu [4]", 1);

	my $sms_zostalo2 = 666;
	if ($res->content =~ /Limit wiadomoci ([0-9]+)\./) { $sms_zostalo2 = $1; }
	if ($sms_zostalo2 == 666) { zakoncz ("Nie mog odczyta iloci dostpnych SMSw", 1); }

	if ($sms_zostalo > $sms_zostalo2) {
		print ("Wszystko OK; pozostay limit wiadomoci: ".$sms_zostalo2."\n"); 
	} else {
		print ("Wiadomo wysana, ale STATUS NIEZNANY (pozostay limit: ".$sms_zostalo2.").\n");
	}
}

exit 0;
